%% REALIMENTACIN DE ESTADOS MIMO
clear all;
close all;
clc;
A=[.99,0,0,0;9e-3,.905,0,0;0,0,.951,0;.02,0,.02,1];
B=[.01,0;5e-5,0;0,.049;1e-4,5e-4];
C=[0,1,0,0;0,0,0,1];
D=zeros(2,2);
T=0.01;
P1=ss(A,B,C,D,T);
disp('  MODELO DE ESTADOS DISCRETO');
P1
%% Controlabilidad
clc;
U=ctrb(P1.a,P1.b);
disp('  MATRIZ CONTROLABILIAD');
U
disp('  ');
disp('  RANGO');
rank(U)

%% Controlabilidad Parcial
clc;
U1=ctrb(P1.a,P1.b(:,1));
disp('  MATRIZ CONTROLABILIDAD POR LA ENTRADA U1');
U1
disp('  ');
disp('  RANGO');
rank(U1)
U2=ctrb(P1.a,P1.b(:,2));
disp('  MATRIZ CONTROLABILIDAD POR LA ENTRADA U2');
U2
disp('  ');
disp('  RANGO');
rank(U2)

%% AUTOVALORES
clc;
disp('  SOBREPICO = 10%');
disp('  TIEMPO DE ESTABLECIMIENTO = 0.5 SEG');
disp('  ');
Sp=.1;
Ts=.5;
Psi=-log(Sp)/((log(Sp))^2+pi^2)^.5;
mens=sprintf('          EL AMORTIGUAMIENTO ES %6.3f',Psi);
disp(mens);
Wn=3/Psi/Ts;
mens=sprintf('          LA FRECUENCIA NATURAL ES %6.3f',Wn);
disp(mens);
G4=tf([Wn^2],[1 (2*Psi*Wn) Wn^2]);
disp(' ');
disp('autovalores deseados continuos');
disp(' ');
Pg4=pole(G4)
G5=c2d(G4,T);
disp('autovalores deseados discretos');
disp(' ');
Pg5=pole(G5)
disp('agrego el tercer polo a la frecuencia s=-60');
disp(' ');
disp(' ');
p3=exp(-60*T)
disp('agrego el cuarto polo a la frecuencia s=-100');
disp(' ');
p4=exp(-100*T)
P=[Pg5' p3 p4]
%% CALCULO DE LA REALIMENTACIN
clc;
disp(' MATRIZ DE AGRUPACIN DE ENTARDAS');
disp(' ');
H=[1;1]
disp(' VECTOR DE ENTRADA FICTICIA');
B1=P1.b*H
disp(' ');
disp(' CONTROLABILIDAD');
U3=ctrb(P1.a,B1)
disp(' ');
disp(' RANGO');
rank(U3)
%% Vector de Realimentacin

K1=acker(P1.a,B1,P);
clc;
disp(' VECTOR DE REALIMENTACIN');
disp(' ');
K1

disp(' MATRIZ DE REALIMENTACIN');
disp(' ');
K=H*K1

%% MODELO REALIMENTADO

At=P1.a-P1.b*K
P2=P1;
P2.a=At;
clc;
disp(' MODELO DE ESTADO REALIMENTADO');
P2
disp(' ');
disp(' AUTOVALORES');
%disp(' ');
pole(P2)
disp(' ');
%%
